"use strict";
{
    const C3 = self.C3;
    C3.Plugins.Sparsha_External_Image.Instance = class External_ImageInstance extends C3.SDKWorldInstanceBase
    {
        constructor(inst, properties)
        {
            super(inst);

            //this._testProperty = 0;

            if (properties)
            {
                //this._testProperty = properties[0];
            }
            this.PluginCnds = C3.Plugins.Sparsha_External_Image.Cnds;

            this.isLoaded = false;
            this.isNew = false;

            this.texture = null;
            this.myImageBitmap = null;
            this.myW = 0;
            this.myH = 0;
        }

        Release()
        {
            super.Release();
        }

        Draw(renderer)
        {
            let texture = null
            let rcTex = null
            let imageInfo = null

            if (this.isLoaded && this.isNew)
            {
                this.isNew = false;
                if (this.texture)
                {
                    renderer.DeleteTexture(this.texture);
                }
                this.texture = renderer.CreateDynamicTexture(this.myW, this.myH,
                {
                    mipMap: false
                });
                renderer.UpdateTexture(this.myImageBitmap, this.texture,
                {});
                texture = this.texture;
                rcTex = new C3.Rect(0, 0, 1, 1)
            }
            else if (this.isLoaded)
            {
                renderer.UpdateTexture(this.myImageBitmap, this.texture,
                {});
                texture = this.texture;
                rcTex = new C3.Rect(0, 0, 1, 1)
            }
            else
            {
                imageInfo = this._objectClass.GetImageInfo();
                this.myW = imageInfo._width;
                this.myH = imageInfo._height;
                texture = imageInfo.GetTexture();
                rcTex = imageInfo.GetTexRect();
            }

            if (!texture) return; // dynamic texture load which hasn't completed yet; can't draw anything

            const wi = this.GetWorldInfo();
            const quad = wi.GetBoundingQuad();

            renderer.SetTexture(texture);

            if (this._runtime.IsPixelRoundingEnabled())
            {
                const ox = Math.round(wi.GetX()) - wi.GetX();
                const oy = Math.round(wi.GetY()) - wi.GetY();
                tempQuad.copy(quad);
                tempQuad.offset(ox, oy);
                renderer.Quad3(tempQuad, rcTex);
            }
            else
            {
                renderer.Quad3(quad, rcTex);
            }
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }

        GetDebuggerProperties()
        {
            return [
            {
                title: "External_Image",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }

        // timeline support
        GetPropertyValueByIndex(index)
        {
            return 0;
        }

        SetPropertyValueByIndex(index, value)
        {
            //set property value here
        }
    };
}